package no.vegvesen.meldingsformidler

import java.net.URI

class MeldingsformidlerEnvironment private constructor(
    val baseUri: URI,
) {

    companion object {
        val Localhost = MeldingsformidlerEnvironment(SendMeldingEnvironment.Localhost.baseUri)
        val Systemtest = MeldingsformidlerEnvironment(SendMeldingEnvironment.Systemtest.baseUri)
        val Akseptansetest = MeldingsformidlerEnvironment(SendMeldingEnvironment.Akseptansetest.baseUri)
        val Produksjon = MeldingsformidlerEnvironment(SendMeldingEnvironment.Produksjon.baseUri)

        fun customOverride(
            sendMeldingEnvironmentBaseUri: URI,
        ): MeldingsformidlerEnvironment = MeldingsformidlerEnvironment(sendMeldingEnvironmentBaseUri)
    }
}

enum class SendMeldingEnvironment(val baseUri: URI) {
    Localhost(URI.create("http://localhost:17113")),
    Systemtest(URI.create("https://meldingsmottak.utv.atlas.vegvesen.no")),
    Akseptansetest(URI.create("https://meldingsmottak.test.atlas.vegvesen.no")),
    Produksjon(URI.create("https://meldingsmottak.atlas.vegvesen.no"));
}
