package no.vegvesen.meldingsformidler

import ArbitraryTestData.arbirtryBevisHolder
import ArbitraryTestData.arbitraryBevis
import no.vegvesen.meldingsformidler.common.domain.ColorHex
import no.vegvesen.meldingsformidler.common.domain.Fodselsnummer
import org.junit.Assert.assertThrows
import org.junit.jupiter.api.Test

class BevisTest {

    @Test
    fun `Bevis bakgrunnsfarge throws Exception when not valid hex code`() {
        assertThrows(IllegalArgumentException::class.java) {
            arbitraryBevis(bakgrunnsfarge = ColorHex("#12305P"))
        }
    }

    @Test
    fun `fodelsenummer throws throws Exception when not null and empty`() {
        assertThrows(IllegalArgumentException::class.java) {
            arbitraryBevis(bevisBevisHolder = arbirtryBevisHolder(fodselsnummer = Fodselsnummer("")))
        }
    }

    @Test
    fun `UtstederVisningsnavn throws throws Exception when empty`() {
        assertThrows(IllegalArgumentException::class.java) {
            arbitraryBevis(utstederVisningsnavn = "")
        }
    }

    @Test
    fun `beivs can be created with gyldighetsperiode null`() {
        arbitraryBevis(gyldighetsperiode = null)
    }

}

