package no.vegvesen.meldingsformidler

import io.mockk.every
import io.mockk.mockk
import no.vegvesen.meldingsformidler.common.openamclient.OpenAmClient
import org.assertj.core.api.Assertions.assertThat
import org.junit.jupiter.api.Test
import java.net.ConnectException
import java.net.http.HttpClient
import java.net.http.HttpRequest
import java.net.http.HttpResponse

class MeldingsformidlerClientTest {

    private val openAmClient: OpenAmClient = mockk(relaxed = true)
    private val httpClient: HttpClient = mockk(relaxed = true)
    private val client = MeldingsformidlerClient(MeldingsformidlerEnvironment.Localhost, openAmClient, httpClient)


    @Test
    fun `health endpoint returns unreachable if a connect exception occurs`() {
        val expected = MeldingsformidlerEndpointHealth.NotReachable
        every { httpClient.send(any<HttpRequest>(), any<HttpResponse.BodyHandler<String>>()) } throws ConnectException()

        val actual = client.health()

        assertThat(actual).isEqualTo(expected)
    }

}
